VERSION 5.00
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Test"
   ClientHeight    =   6000
   ClientLeft      =   3270
   ClientTop       =   1995
   ClientWidth     =   6750
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6000
   ScaleWidth      =   6750
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   4800
      TabIndex        =   2
      Top             =   5340
      Width           =   1875
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   2430
      TabIndex        =   1
      Top             =   5340
      Width           =   1875
   End
   Begin VB.CommandButton cmdTryIt 
      Caption         =   "Try It"
      Height          =   495
      Left            =   60
      TabIndex        =   0
      Top             =   5340
      Width           =   1875
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdTryIt_Click()
    
    On Error GoTo cmdTryIt_Click_Error
    
    Cls
    
    ' Make the top-level subdirectories below the root with the MkDir statement ...
    MkDir "A:\SYSTEM"
    MkDir "A:\COMMAND"
    MkDir "A:\EXECUTE"
    MkDir "A:\INITIAL"
    MkDir "A:\TEXT"
    MkDir "A:\WRITE"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Top-level directories have been made."
    Refresh
    
    ' To faciliate the moving of the files to their proper directories, a Sub named
    ' CopyOrMoveFiles was written. The Sub takes four arguments: (1) source path,
    ' (2) target path, (3) file extension, and (4) a one-character code indicating
    ' whether the files should be moved ("M") or copied ("C"). The Sub is called six
    ' times, once for each file type to be moved from the root to its proper directory.
    CopyOrMoveFiles "A:\", "A:\SYSTEM", "SYS", "M"
    CopyOrMoveFiles "A:\", "A:\COMMAND", "COM", "M"
    CopyOrMoveFiles "A:\", "A:\EXECUTE", "EXE", "M"
    CopyOrMoveFiles "A:\", "A:\INITIAL", "INI", "M"
    CopyOrMoveFiles "A:\", "A:\TEXT", "TXT", "M"
    CopyOrMoveFiles "A:\", "A:\WRITE", "WRI", "M"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been moved from root to top-level directories."
    Refresh
    
    ' Create the EXE_INI directory below the SYSTEM directory with MkDir ...
    MkDir "A:\SYSTEM\EXE_INI"
    Print "Second-level directory for EXE and INI files has been made."
    ' Use the "CopyOrMoveFiles" Sub to copy the EXEs and INIs to the
    ' newly-created directory ...
    CopyOrMoveFiles "A:\EXECUTE", "A:\SYSTEM\EXE_INI", "EXE", "C"
    CopyOrMoveFiles "A:\INITIAL", "A:\SYSTEM\EXE_INI", "INI", "C"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been copied to EXE_INI directory."
    Refresh

    ' Create the TXT_WRI directory below the INITIAL directory with MkDir ...
    MkDir "A:\INITIAL\TXT_WRI"
    Print "Second-level directory for TXT and WRI files has been made."
    ' Use the "CopyOrMoveFiles" Sub to copy the TXTs and WRIs to the
    ' newly-created directory ...
    CopyOrMoveFiles "A:\TEXT", "A:\INITIAL\TXT_WRI", "TXT", "C"
    CopyOrMoveFiles "A:\WRITE", "A:\INITIAL\TXT_WRI", "WRI", "C"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been copied to TXT_WRI directory."
    Refresh
    
    Print "Done."

    Exit Sub

cmdTryIt_Click_Error:
    
    MsgBox "The following error has occurred:" & vbNewLine _
         & "Error # " & Err.Number & " - " & Err.Description, _
           vbCritical, _
           "File System Commands Demo - Error"

End Sub

Private Sub cmdReset_Click()
    
    On Error GoTo cmdReset_Click_Error
    
    Cls
    
    ' Delete all of the files in the EXE_INI directory below the SYSTEM directory ...
    Kill "A:\SYSTEM\EXE_INI\*.*"
    ' Now that the EXE_INI directory is clear, remove it with RmDir
    RmDir "A:\SYSTEM\EXE_INI"
    ' Use the CopyOrMoveFiles Sub to move the SYS files from the SYSTEM directory
    ' back to the root ...
    CopyOrMoveFiles "A:\SYSTEM", "A:\", "SYS", "M"
    ' Moving the SYS files out of the SYSTEM directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\SYSTEM\"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "SYSTEM directory has been cleared; files moved back to root."
    Refresh

    ' Use the CopyOrMoveFiles Sub to move the COM files from the COMMAND directory
    ' back to the root ...
    CopyOrMoveFiles "A:\COMMAND", "A:\", "COM", "M"
    ' Moving the COM files out of the COMMAND directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\COMMAND"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "COMMAND directory has been cleared; files moved back to root."
    Refresh
    
    ' Use the CopyOrMoveFiles Sub to move the EXE files from the EXECUTE directory
    ' back to the root ...
    CopyOrMoveFiles "A:\EXECUTE", "A:\", "EXE", "M"
    ' Moving the EXE files out of the EXECUTE directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\EXECUTE"

    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "EXECUTE directory has been cleared; files moved back to root."
    Refresh
    
   ' Delete all of the files in the TXT_WRI directory below the INITIAL directory ...
    Kill "A:\INITIAL\TXT_WRI\*.*"
    ' Now that the TXT_WRI directory is clear, remove it with RmDir
    RmDir "A:\INITIAL\TXT_WRI"
    ' Use the CopyOrMoveFiles Sub to move the INI files from the INITIAL directory
    ' back to the root ...
    CopyOrMoveFiles "A:\INITIAL", "A:\", "INI", "M"
    ' Moving the INI files out of the INITIAL directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\INITIAL"

    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "INITIAL directory has been cleared; files moved back to root."
    Refresh
    
    ' Use the CopyOrMoveFiles Sub to move the TXT files from the TEXT directory
    ' back to the root ...
    CopyOrMoveFiles "A:\TEXT", "A:\", "TXT", "M"
    ' Moving the TXT files out of the TEXT directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\TEXT"

    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "TEXT directory has been cleared; files moved back to root."
    Refresh
    
    ' Use the CopyOrMoveFiles Sub to move the WRI files from the WRITE directory
    ' back to the root ...
    CopyOrMoveFiles "A:\WRITE", "A:\", "WRI", "M"
    ' Moving the WRI files out of the WRITE directory should have cleared it, so
    ' it now can be removed with RmDir ...
    RmDir "A:\WRITE"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "WRITE directory has been cleared; files moved back to root."
    Print "Done."
    Refresh
    
    Exit Sub

cmdReset_Click_Error:
    
    MsgBox "The following error has occurred:" & vbNewLine _
         & "Error # " & Err.Number & " - " & Err.Description, _
           vbCritical, _
           "File System Commands Demo - Error"
    
End Sub

Private Sub cmdExit_Click()
    End
End Sub

Private Sub CopyOrMoveFiles(pstrSourcePath As String, _
                            pstrTargetPath As String, _
                            pstrExtension As String, _
                            pstrCopyOrMoveCode As String)

' This Sub takes four arguments: (1) source path, (2) target path, (3) file extension,
' and (4) a one-character code indicating whether the files should be moved ("M") or
' copied ("C").

    Dim strCurrentFile  As String
    Dim strPattern      As String
    Dim strSourceFile   As String
    Dim strTargetFile   As String
    
    ' If the source path does not already have a backslash at
    ' the end of it, add one ...
    If Right$(pstrSourcePath, 1) <> "\" Then
        pstrSourcePath = pstrSourcePath & "\"
    End If

    ' If the target path does not already have a backslash at
    ' the end of it, add one ...
    If Right$(pstrTargetPath, 1) <> "\" Then
        pstrTargetPath = pstrTargetPath & "\"
    End If
    
    ' Create the "source pattern" by concatenating the source path, "*.", and
    ' the extension. For example, if "A:\" was passed in as the source path and
    ' "SYS" was passed in as the extension, the value of strPattern would be
    ' "A:\*.SYS".
    strPattern = pstrSourcePath & "*." & pstrExtension

    ' Use the pattern created above as the initial argument to the Dir$ function.
    ' The strCurrentFile variable will be used to hold the matching files (one at
    ' a time, as returned by successive calls to the Dir$ function).
    strCurrentFile = Dir$(strPattern)
    
    ' Set up a loop to copy the matching files from the source path to the target
    ' path. The loop will stop when there are no more matching files.
    Do Until strCurrentFile = ""
        ' Create the source file name that will be used in the FileCopy statement
        ' by concatenating the source path with the filename last returned by the
        ' Dir$ function. For example, if the source path was "A:\", and the current
        ' filename returned by Dir$ was "TESTSYS1.SYS", then the value of strSourceFile
        ' would be "A:\TESTSYS1.SYS".
        strSourceFile = pstrSourcePath & strCurrentFile
        ' Create the target file name that will be used in the FileCopy statement
        ' by concatenating the target path with the filename last returned by the
        ' Dir$ function. For example, if the target path was "A:\SYSTEM\", and the
        ' current filename returned by Dir$ was "TESTSYS1.SYS", then the value of
        '  strTargetFile would be "A:\SYSTEM\TESTSYS1.SYS".
        strTargetFile = pstrTargetPath & strCurrentFile
        ' Use FileCopy to copy the source file to its target destination ...
        FileCopy strSourceFile, strTargetFile
        ' Get the next matching file by calling the Dir$ function with no arguments.
        strCurrentFile = Dir$()
    Loop
    
    ' If the "Copy or Move code" passed in was "M" (for move), then we need to delete
    ' the files that we just copied to a new location. Since the native VB file I/O
    ' statements do not include a "move file" statement specifically, a move must be
    ' be accomplished by first copying a file to its new destination, then deleting it
    ' from its original location. The Kill statement is used to delete one or more files
    ' (it will accept a file specification that uses a pattern). For example, if the
    ' variable strPattern contained "A:\*.SYS", the Kill statement below would be
    ' equivalent to the MS-DOS/Windows command-line command "DEL A:\*.SYS".
    If pstrCopyOrMoveCode = "M" Then
        Kill strPattern
    End If
    
End Sub
